#include <stdint.h>
#include "sqrt.h"

uint16_t sqrt32(uint32_t x) {
    uint16_t z, b;
    z = 0;
    for (b = 1<<15; b > 0; b >>= 1)
        if ((uint32_t)(z + b) * (z + b) <= x)
            z += b;
    return z;
}
